var EFile = {} // these are needed due to object type name variations
var EFiling = {} // these are needed due to object type name variations

/** the name of the form (set when the BODY loads) */
EFile.FORM_NAME = null;
EFile.OBJECT_TYPE = null;
EFile.KEY = null;
EFile.ID = null;
EFile.EDITABLE = false;
EFile.REFERRER = null;
EFile.FORM_CONFIG_RK = 0;

EFiling.ID = null;
EFile.ID = EFiling.ID;

EFiling.editReport = function(/* long */rowId, /* string */uiContextId, /*string*/typeCode) {
   var title = AppProperties["edit.report.header.txt"];
   var url = Global.CONTEXT_PATH + "/EFiling.do?command=view&rowId=" + rowId
         + "&parentUIContextId=" + uiContextId + "&EFILE.EFILE_TYPE_CD=" + typeCode
         + "&transactionType=0";
   IFrameDialog.show( {
      url :url,
      title :title,
      width: 400, height: 300
   });
}

EFiling.newEFile = function()
{
   var url = Global.CONTEXT_PATH + "/EFiling.do?command=newEntity";
   IFrameDialog.show({
      url: url,
      width: 500, height: 200,
      title: AppProperties["newEFile.title.txt"]});
}

EFiling.getForm = function() {
   return document.getElementById(EFile.FORM_NAME);
}

EFiling.submitForm = function(valueMap)
{
   FormUtil.submitForm(EFiling.getForm(), valueMap);
}

EFiling.save = function(form)
{
   if (!form)
   {
      form = EFiling.getForm();
   }
   App.protectPage();
   EFiling.handleDefaultSubmit(form);
   form.submit();
}

EFiling.saveDraft = function(form)
{
   if (!form)
   {
      form = EFiling.getForm();
   }
   App.protectPage();
   EFiling.handleDraftSubmit(form);
   form.submit();
}

EFiling.saveNew = function()
{
   var form = EFiling.getForm();
   EFiling.handleNewDefaultSubmit(form);
   form.submit();
}

EFiling.handleDefaultSubmit = function(form)
{
   FormUtil.updateForm(form, {command: "save"});
}

EFiling.handleDraftSubmit = function(form)
{
   FormUtil.updateForm(form, {command: "saveDraft"});
}

EFiling.handleNewDefaultSubmit = function(form)
{
   form.target = "_top";
   var formValueMap = {command: "save", isNewEntity: "true"};
   FormUtil.updateForm(form, formValueMap);
}

EFiling.comments = function() {
   Comments.showDialog(EFile.KEY, EFile.OBJECT_TYPE, AppProperties["efile.title.txt"] + "&nbsp;" + EFile.ID);
}

EFiling.attachments = function() {
   var url = Global.CONTEXT_PATH + "/Attachments.do?command=display&key=" + EFile.KEY + "&objType=" + EFile.OBJECT_TYPE;
   var title =
      AppProperties["attachments.title.txt"] +
      "&nbsp;&#149;&nbsp;" +
      AppProperties["efile.title.txt"] +
      "&nbsp;" +
      EFile.ID;
   IFrameDialog.show({url: url, title: title});

}

EFiling.cancelNew = function() {
   if (window.parent && window.parent.Dialog && window.parent.Dialog.activeDialog)
   {
      window.parent.Dialog.activeDialog.hide();
      window.parent.App.unprotectPage();
   }
   else
   {
      window.location = Global.CONTEXT_PATH + "/ReportConsoleSearch.do";
   }
}

EFiling.handleReassignDefaultSubmit = function(form)
{
   FormUtil.updateForm(form, {command :"reassign"});
}

EFiling.reassignSubmit = function(form)
{
   var form = EFiling.getForm();
   EFiling.handleReassignDefaultSubmit(form);
   form.submit();
}

EFiling.reassignCancel = function()
{
   window.parent.Dialog.activeDialog.hide();
}

EFiling.closeReassignDialog = function()
{
   if (window.parent.Reports !== undefined)
   {
      window.parent.EFiling.submitForm();
   }
   else if (window.parent.Search)
   {
      window.parent.Search.refresh();
   }
}

/**
 * This method is invoked to open a different URL. If changes have been
 * made to the current page then a "Save Changes" confirmation dialog is
 * shown before redirecting.
 */
EFiling.redirect = function(redirectURL)
{
   var args = {redirectURL: redirectURL};
   SaveChangesConfirmation.confirmSaveChanges(
         EFiling.saveChangesConfirmationCallback, args);
}

EFiling.logoff = function()
{
   EFiling.redirect("Logoff");
}

EFiling.saveChangesConfirmationCallback = function(saveChangesConfirmation)
{
   App.protectPage();
   
   var resultCode = saveChangesConfirmation.resultCode;
   
   if (resultCode == SaveChangesConfirmation.ResultCode.YES)
   {
      var separator = "?";
      if (saveChangesConfirmation.args.redirectURL.indexOf("?") > -1)
      {
         separator = "&";
      }
      var redirectURL = saveChangesConfirmation.args.redirectURL + separator + "efileSaved=" + EFile.KEY;
      
      /* save the case but provide a redirect URL */
      var form = EFiling.getForm();
      FormUtil.updateForm(form, {redirectURL: redirectURL});
      EFiling.saveDraft(form);
   }
   else if ((resultCode == SaveChangesConfirmation.ResultCode.NO) ||
            (resultCode == SaveChangesConfirmation.ResultCode.NOT_DIRTY))
   {
      /* user does not want to save or the page is not dirty */
      window.location = saveChangesConfirmation.args.redirectURL;
   }
}