var Party = {};

/** the name of the form (set when the BODY loads) */
Party.FORM_NAME = null;
Party.OBJECT_TYPE = null;
Party.KEY = null;
Party.ID = null;
Party.EDITABLE = false;
Party.REFERRER = null;
Party.TITLE = null;

Party.getForm = function()
{
   return document.getElementById(Party.FORM_NAME);
};

Party.submitForm = function(valueMap)
{
   FormUtil.submitForm(Party.getForm(), valueMap);
};

Party.save = function(form)
{
   if (!form)
   {
      form = Party.getForm();
   }

   var form = Party.getForm();
   Party.handleDefaultSubmit(form);
   form.submit();
};

Party.saveNew = function()
{
   var form = Party.getForm();
   if (Party.handleNewDefaultSubmit(form)) 
   {
      form.submit();
   }
};

Party.handleDefaultSubmit = function(form)
{
   App.protectPage();
   FormUtil.updateForm(form, {command: "save"});
};

Party.handleNewDefaultSubmit = function(form)
{
   form.target = "_top";
   if (form.Relationship) 
   {
      var rels = Party.getRelationships(form);
      FormUtil.updateForm(form, {
               command :"save", 
               isNewEntity :"true", 
               relationshipTypes :rels,
               relationshipDescriptions :Party.getDescriptions(form)
      });
   } 
   else 
   {
      FormUtil.updateForm(form, {command: "save", isNewEntity: "true"});
   }
   return true;
};

Party.comments = function()
{
   Comments.showDialog(Party.KEY, Party.OBJECT_TYPE, AppProperties["party.title.txt"] + "&nbsp;" + Party.ID);
};

Party.attachments = function()
{
   var url = Global.CONTEXT_PATH + "/Attachments.do?command=display&key=" + Party.KEY + "&objType=" + Party.OBJECT_TYPE;
   var title =
       AppProperties["attachments.title.txt"] +
       "&nbsp;&#149;&nbsp;" +
       AppProperties["party.title.txt"] +
       "&nbsp;" +
       Party.ID;
   IFrameDialog.show({url: url, title: title});
};

Party.cancelNew = function()
{
   if (window.parent && window.parent.Dialog && window.parent.Dialog.activeDialog)
   {
      window.parent.Dialog.activeDialog.hide();
      window.parent.App.unprotectPage();
   }
   else
   {
      window.location = Global.CONTEXT_PATH + "/PartySearch.do";
   }
};

Party.handleFormOnSubmit = function(form)
{
   return true;
};

Party.logoff = function()
{
   Party.redirect("Logoff");
};

Party.redirect = function(redirectURL)
{
   var args = {redirectURL: redirectURL};
   SaveChangesConfirmation.confirmSaveChanges(Party.saveChangesConfirmationCallback, args);
};

Party.saveChangesConfirmationCallback = function(saveChangesConfirmation)
{
   App.protectPage();
   
   var resultCode = saveChangesConfirmation.resultCode;
   
   if (resultCode == SaveChangesConfirmation.ResultCode.YES)
   {
      var separator = "?";
      if (saveChangesConfirmation.args.redirectURL.indexOf("?") > -1)
      {
         separator = "&";
      }
      var redirectURL = 
            saveChangesConfirmation.args.redirectURL + separator + "partySaved=" + Party.KEY;
      
      /* save the party but provide a redirect URL */
      var form = Party.getForm();
      FormUtil.updateForm(form, {redirectURL: redirectURL});
      Party.save(form);
   }
   else if ((resultCode == SaveChangesConfirmation.ResultCode.NO) ||
            (resultCode == SaveChangesConfirmation.ResultCode.NOT_DIRTY))
   {
      /* user does not want to save or the page is not dirty */
      window.location = saveChangesConfirmation.args.redirectURL;
   }
};

Party.getRelationships = function(form) {
   var cb = new Array();

   form = FormUtil.getForm(form);
   var relationshipArray = null;
   if (form.Relationship.length) {
      relationshipArray = form.Relationship;
   }
   else {
      relationshipArray = [ form.Relationship ];
   }
   
   for ( var i = 0; i < relationshipArray.length; i++) {
      if (relationshipArray[i].checked && !relationshipArray[i].disabled) {
         cb.push(relationshipArray[i].value);
      }
   }

   return cb;
};

Party.getDescriptions = function(form) {
  var desc = "";
  var somethingAdded = false; // Add separators but know when blank descriptions have been added

  form = FormUtil.getForm(form);
  var relationshipArray = null;
  var descArray = null;
  if (form.Relationship.length) {
     relationshipArray = form.Relationship;
     descArray = form.Description;
  }
  else {
     relationshipArray = [ form.Relationship ];
     descArray = [ form.Description ];
  }
  for(var i=0;i < relationshipArray.length;i++)
  {
     if(relationshipArray[i].checked && !relationshipArray[i].disabled)
     {
        var value = descArray[i].value;
        if (somethingAdded)
        {
           desc = desc + "#,,#"; // special separator so commas in the description fields won't break this.
        }
        desc = desc + value;
        somethingAdded = true;
     }
  }
  return desc;
};

Party.networkGraph = function(url)
{
   var popupFeatures = 
   {
      width: 700,
      height: 700
   };
   BrowserUtil.openPopup(url, '_blank', popupFeatures, true);
};

Party.handleOnLoad = function()
{
   // register breadcrumb
   App.addBreadcrumb(Party.REFERRER);
}