var PreviewReport = {};

PreviewReport.PREVIEW_ERROR = null;
PreviewReport.STORED_PROCESS_PARAMETERS = null;

PreviewReport.createURL = function(command, args)
{
   var url = Global.CONTEXT_PATH + "/PreviewReport.do?command=" + command;
   
   for (var key in args)
   {
      var value = args[key];
      url += "&" + key + "=" + value;
   }
   return url;
}

PreviewReport.showPopup = function(command)
{
   var url = PreviewReport.createURL(command, PreviewReport.STORED_PROCESS_PARAMETERS);
   
   var popupFeatures = {
         width: 900,
         height: 600
      };
   PreviewReport.openPopup(url, "previewReportPopup", popupFeatures);
}

PreviewReport.showEFileReportsPopup = function(command, args)
{
   var url = PreviewReport.createURL(command, args);
   
   var popupFeatures = {
         width: 900,
         height: 600
      };
   PreviewReport.openPopup(url, "previewReportPopup", popupFeatures);
}


PreviewReport.preview = function()
{
   var args = {command: "previewReport"};
   SaveChangesConfirmation.confirmSaveChanges(
         PreviewReport.saveChangesConfirmationCallback, args);
}

PreviewReport.previewFromEFile = function(key, form_key)
{
   var command = "previewReport";
   var args = {rr_rk: key, form_config_rk: form_key};
   PreviewReport.showEFileReportsPopup(command, args);
}


PreviewReport.previewSubmit = function()
{
   var args = {command: "previewSubmit"};
   SaveChangesConfirmation.confirmSaveChanges(
         PreviewReport.saveChangesConfirmationCallback, args);
}

PreviewReport.close = function()
{
   window.close();
}

PreviewReport.submit = function(args)
{
   if (!window.parent.PreviewReport.PREVIEW_ERROR)
   {
      BrowserUtil.setRequestParameter("command", "submit");
      window.location = BrowserUtil.getRequestURL().toString();
   }
}

PreviewReport.openPopup = function(url, name, features, replace)
{
   if (!features)
   {
      features = {};
   }
   
   if (features.scrollbars === undefined)
   {
      features.scrollbars = 'yes';
   }
   
   if (features.resizable === undefined)
   {
      features.resizable = 'yes';
   }
   
   if (features.width === undefined)
   {
      features.width = 800;
   }
   
   if (features.height === undefined)
   {
      features.height = 600;
   }
   
   var featureStr = "";
   for (var key in features)
   {
      var value = features[key];
      if (featureStr.length > 0)
      {
         featureStr += ",";
      }
      
      if (value)
      {
         featureStr += key + "=" + value;
      }
      else
      {
         featureStr += key + "=";
      }
   }
   
   var popup = window.open(url, name, featureStr, replace);
   if (popup)
   {
      popup.focus();
   }
   return popup;
}

PreviewReport.disableSubmit = function()
{
   var okButton = window.mainToolBar.menuItems[0];
   
   if (okButton.model.id == "okButton")
   {
      okButton.setDisabled(true);
   }
}

PreviewReport.enableSubmitIfAllowed = function()
{
   if (PreviewReport.PREVIEW_ERROR === true)
   {
      return;
   }
   
   var okButton = window.mainToolBar.menuItems[0];
   
   if (okButton.model.id == "okButton")
   {
      okButton.setDisabled(false);
   }
}

PreviewReport.saveChangesConfirmationCallback = function(saveChangesConfirmation)
{
   var resultCode = saveChangesConfirmation.resultCode;
   
   if (resultCode == SaveChangesConfirmation.ResultCode.YES)
   {
      /* save the report but provide a redirect URL */
      var form = Reports.getForm();
      FormUtil.updateForm(form, {onload: "PreviewReport." + saveChangesConfirmation.args.command});
      Reports.saveDraft(form);
   }
   else if (resultCode == SaveChangesConfirmation.ResultCode.NO)
   {
      /* user does not want to save */
      PreviewReport.STORED_PROCESS_PARAMETERS["dirty"] = true;
      PreviewReport.showPopup(saveChangesConfirmation.args.command);
   }
   else if (resultCode == SaveChangesConfirmation.ResultCode.NOT_DIRTY)
   {
      /* the page is not dirty */
      PreviewReport.showPopup(saveChangesConfirmation.args.command);
   }
}

/**
 * This function is called when the page loads.
 */
PreviewReport.handleOnLoad = function()
{
   var onload = BrowserUtil.getRequestParameter("onload");
   if (!onload || App.HAS_ERRORS)
   {
      return;
   }
   
   if (onload == "PreviewReport.preview")
   {
      PreviewReport.preview();
   }
}