var SARFiling = {};

SARFiling.PREVIEW_ERROR = null;
SARFiling.STORED_PROCESS_PARAMETERS = null;
/*SARFiling.WARNING_MSG_TEXT = null;*/

SARFiling.createURL = function(command, args)
{
   var url = Global.CONTEXT_PATH + "/SARFiling.do?command=" + command;
   
   for (var key in args)
   {
      var value = args[key];
      url += "&" + key + "=" + value;
   }
   return url;
}

SARFiling.showPopup = function(command)
{
   var url = SARFiling.createURL(command, SARFiling.STORED_PROCESS_PARAMETERS);
   
   var popupFeatures = {
         width: 900,
         height: 600
      };
   SARFiling.openPopup(url, "efilingPopup", popupFeatures);
}

SARFiling.preview = function()
{
   var args = {command: "preview"};
   SaveChangesConfirmation.confirmSaveChanges(
         SARFiling.saveChangesConfirmationCallback, args);
}

SARFiling.submit = function()
{
/*	if (confirm(SARFiling.WARNING_MSG_TEXT)) */
	if (confirm("Make sure you have reviewed the report as this step is irreversible."))
	{
       var args = {command: "submit"};
       SaveChangesConfirmation.confirmSaveChanges(
         SARFiling.saveChangesConfirmationCallback, args);
	}
}

SARFiling.close = function()
{
   window.close();
}



SARFiling.openPopup = function(url, name, features, replace)
{
   if (!features)
   {
      features = {};
   }
   
   if (features.scrollbars === undefined)
   {
      features.scrollbars = 'yes';
   }
   
   if (features.resizable === undefined)
   {
      features.resizable = 'yes';
   }
   
   if (features.width === undefined)
   {
      features.width = 800;
   }
   
   if (features.height === undefined)
   {
      features.height = 600;
   }
   
   var featureStr = "";
   for (var key in features)
   {
      var value = features[key];
      if (featureStr.length > 0)
      {
         featureStr += ",";
      }
      
      if (value)
      {
         featureStr += key + "=" + value;
      }
      else
      {
         featureStr += key + "=";
      }
   }
   
   var popup = window.open(url, name, featureStr, replace);
   if (popup)
   {
      popup.focus();
   }
   return popup;
}

SARFiling.disableSubmit = function()
{
   var okButton = window.mainToolBar.menuItems[0];
   
   if (okButton.model.id == "okButton")
   {
      okButton.setDisabled(true);
   }
}

SARFiling.enableSubmitIfAllowed = function()
{
   if (SARFiling.PREVIEW_ERROR === true)
   {
      return;
   }
   
   var okButton = window.mainToolBar.menuItems[0];
   
   if (okButton.model.id == "okButton")
   {
      okButton.setDisabled(false);
   }
}

SARFiling.saveChangesConfirmationCallback = function(saveChangesConfirmation)
{
   var resultCode = saveChangesConfirmation.resultCode;
   
   if (resultCode == SaveChangesConfirmation.ResultCode.YES)
   {
      /* save the case but provide a redirect URL */
      var form = Case.getForm();
      FormUtil.updateForm(form, {onload: "SARFiling." + saveChangesConfirmation.args.command});
      Case.save(form);
   }
   else if (resultCode == SaveChangesConfirmation.ResultCode.NO)
   {
      /* user does not want to save */
      SARFiling.STORED_PROCESS_PARAMETERS["dirty"] = true;
      SARFiling.showPopup(saveChangesConfirmation.args.command);
   }
   else if (resultCode == SaveChangesConfirmation.ResultCode.NOT_DIRTY)
   {
      /* the page is not dirty */
      SARFiling.showPopup(saveChangesConfirmation.args.command);
   }
}

/**
 * This function is called when the page loads.
 */
SARFiling.handleOnLoad = function()
{
   var onload = BrowserUtil.getRequestParameter("onload");
   if (!onload || App.HAS_ERRORS)
   {
      return;
   }
   
   if (onload == "SARFiling.preview")
   {
      SARFiling.preview }
   else if (onload == "SARFiling.submit")
   {
      SARFiling.submit();
   }
}