var CaseIncidents = {};

CaseIncidents.addCaseIncidentRow = function(componentName, caseKey, uiContextId) {
   var url = "CaseIncidentSearch.do?caseKey=" + caseKey + "&componentName="
         + componentName + "&uiContextId=" + uiContextId;
   IFrameDialog.show({
      url: url,
      width: 800, height: 500,
      title: AppProperties["add.incident.case.action.label.txt"]});
}

CaseIncidents.editIncident = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Incident.do?command=view&viewMode=EDITABLE&key=" + key +
         "&windowLayout=" + windowLayout +
         "&caseKey=" + parentKey;
   Case.redirect(url);
}

CaseIncidents.viewIncident = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Incident.do?command=view&viewMode=READ_ONLY&key=" + key +
         "&windowLayout=" + windowLayout +
         "&caseKey=" + parentKey;
   Case.redirect(url);
}

CaseIncidents.showIncidentDetails = function(id, caseKey, viewMode) {
   App.showPopup("Incident.do?key=" + id + "&caseKey=" + caseKey + "&windowLayout="
         + viewMode, (screen.availWidth - 100), (screen.availHeight - 100), 0,
         1, 0);
}

CaseIncidents.deleteCaseIncidentRow = function(componentName, row, uiContextId) {
   var answer = confirm(AppProperties["case.incident.delete.confirmation.txt"]);
   if (answer == true) {
       CaseIncidents.ajaxRemoveCaseIncidents(componentName, row, uiContextId);
   }

}

CaseIncidents.ajaxSearchCaseIncidents = function(/* String */caseKey, /* String */
      componentName, /* String */incidentKeys, /* String */uiContextId, 
      /* Boolean */ autoLinkPartiesFromIncident, /* Boolean */ autoLinkFinancialItemsFromIncident) {
   /*
    * This local variable is available when the load callback function is
    * invoked (via JavaScript closure).
    */

	var args = {
      autoLinkPartiesFromIncident: autoLinkPartiesFromIncident,
      autoLinkFinancialItemsFromIncident: autoLinkFinancialItemsFromIncident
      };
   
   dojo.io
         .bind( {
            url :"AjaxUpdateCaseIncidents.do"
                  + "?command=ajaxUpdateTableView"
                  + "&selectedResults=" + incidentKeys
                  + "&componentName=" + componentName
                  + "&caseKey=" + caseKey 
                  + "&uiContextId=" + uiContextId
                  + "&autoLinkPartiesFromIncident=" + autoLinkPartiesFromIncident
                  + "&autoLinkFinancialItemsFromIncident=" + autoLinkFinancialItemsFromIncident,
            
                  
             load : function(type, data, evt) {
               CaseIncidents.createJSONCaseIncidentResults(type, data, evt);
               
               var useCase = false;	
               var useCase = CaseIncidents.getFilterStatus(type, data, evt);
               
               if(args.autoLinkPartiesFromIncident)
            	   {
            	   if(useCase)
            	   {
            		   CaseParties.ajaxRefreshCaseParties();
                   }
            	   
            	   else  if(filteredParties !== undefined)  
                   {
                	   
                	   FilteredCaseParties.ajaxRefreshFilteredCasePartiesAll();
                   }
            	   }   
               if((window.FinancialItems !== undefined) && (args.autoLinkFinancialItemsFromIncident)) 
               {
                  FinancialItems.refreshTable(uiContextId);
               }
            	   
            },
            error :CaseIncidents.errorSearchCaseIncidents,
            mimetype :"text/html"
         });

}

CaseIncidents.errorSearchCaseIncidents = function(type, error) {
   // TODO: Move this to a property
   alert("An error occurred trying to retrieve the User Information: "
         + error.message);
}

CaseIncidents.createJSONCaseIncidentResults = function(type, data, evt) {
   // TODO this might need to be changed to accept divId in data
   var divId = dojo.byId("CASEINCIDENTSTABLE_divId");
   var inhere = false;
   divId.innerHTML = data;
   
   if(window.parent.Dialog.activeDialog != null)
      window.parent.Dialog.activeDialog.hide();
   
   SaveChangesConfirmation.setPageDirty();

}

CaseIncidents.getFilterStatus = function(type, data, evt) {
	   // TODO this might need to be changed to accept divId in data
	    
	   var retValue = false;
	   if(typeof filteredParties === 'undefined'){ 
		   retValue = true;		
		 }; 	    
	   return retValue;
	}


CaseIncidents.ajaxRemoveCaseIncidents = function(/* String */componentName, /* int */
      rowId, /* String */uiContextId) {
   dojo.io.bind( {
      url :"AjaxUpdateCaseIncidents.do?command=ajaxUpdateTableView&rowId="
            + rowId + "&componentName=" + componentName + "&uiContextId="
            + uiContextId,
      load :CaseIncidents.createJSONCaseIncidentResults,
      error :CaseIncidents.errorSearchCaseIncidents,
      mimetype :"text/html"
   });
}
