var FilteredCaseParties = {};

/* Name of this component (set when FilteredCasePartiesComponent renders) */
FilteredCaseParties.COMPONENT_NAME = null;


FilteredCaseParties.addFilterCasePartyRow = function(componentName, uiDefType, caseKey,
      uiContextId, relationshipCode, partyType, partyCategory, partySubCategory) {
     var url = "FilterCasePartySearch.do?command=searchForLinkedParties&fieldName=" + componentName	 
       + "&uiDefType=" + uiDefType
       + "&uiContextId=" + uiContextId
       + "&caseKey=" + caseKey
       + "&relationshipCode=" + relationshipCode
       + "&type=" + partyType
       + "&category=" + partyCategory
	   + "&subcategory=" + partySubCategory;
    IFrameDialog.show({
      url: url,
      width: 800, height: 500,
      title: AppProperties["add.subject.case.action.label.txt"]});
}


FilteredCaseParties.ajaxAddLinkedPartyTableRow =  function(button, /* String */ fieldName, /* String */ relationshipCode,
	      /* String */addedPartyKey,  /* String */rels,  /* String */desc, /* String */uiContextId) {
	
	if(FilteredCaseParties.validate(rels)) {
	dojo.io.bind ({
		
		  method: "post",
	      url: "FilterCasePartyRelationship.do",
	      postContent: "command=ajaxUpdateAllTableView"
	           + "&fieldName=" + fieldName
	           + "&relationshipCode=" + relationshipCode
	           + "&addedParty=" + addedPartyKey
	           + "&rels=" + rels
	           + "&desc=" + desc
	           + "&uiContextId=" + uiContextId,
	      load: FilteredCaseParties.createJSONCasePartyResultsAll,	          
	      error: FilteredCaseParties.errorSearchFilteredCaseParties,
	      mimetype:"application/json"
	});
	}
	 else {
		   button.disabled = false;
	 }
}



FilteredCaseParties.refreshFilteredCasePartyTable = function(type, data, evt) {

	   var jsonModel = dojo.json.evalJson(data);
	   
	   var divId = jsonModel.fieldName.toUpperCase() + "_divId";
	   var div = dojo.byId(divId);
	   div.innerHTML = jsonModel.tableContent;
	   if(window.parent.Dialog.activeDialog != null)
	      window.parent.Dialog.activeDialog.hide();
	   
	   SaveChangesConfirmation.setPageDirty();
	}



FilteredCaseParties.getLinkedCasePartyRelationshipDescription = function(/*String*/ form) {
   var f = FormUtil.getForm(form);
   return f.descArea.value;
}



FilteredCaseParties.editParty = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Party.do?command=view&viewMode=EDITABLE&key=" + key +
         "&windowLayout=" + windowLayout +
         "&caseKey=" + parentKey;
   Case.redirect(url);
}

FilteredCaseParties.viewParty = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Party.do?command=view&viewMode=READ_ONLY&key=" + key +
         "&windowLayout=" + windowLayout +
         "&caseKey=" + parentKey;
   Case.redirect(url);
}

FilteredCaseParties.showCasePartyDetails = function(id, caseKey, windowLayout, viewMode) {
   App.showPopup("Party.do?key=" + id + "&caseKey=" + caseKey + "&windowLayout="
         + windowLayout, (screen.availWidth - 100), (screen.availHeight - 100),
         0, 1, 0);
}
 

	

FilteredCaseParties.deleteCasePartyRow = function(fieldName, row, uiContextId) {
   var answer = confirm(AppProperties["case.subject.delete.confirmation.txt"]);
   if (answer == true) {
      FilteredCaseParties.ajaxRemoveFilteredCaseParties(fieldName, row, uiContextId);
   }

}


FilteredCaseParties.ajaxRemoveFilteredCaseParties =function(/* String */fieldName, /* int */
	      rowId, /* String */uiContextId) {
	
	   dojo.io
	         .bind( {
	        	 url :"SelFilteredPartyRelationship.do?command=ajaxUpdateAllTableView&deleteRowId=" + rowId +
	        	 "&fieldName=" + fieldName + 	        	
                 "&uiContextId=" + uiContextId,
                
	            load :FilteredCaseParties.createJSONCasePartyResultsAll,
	            error :FilteredCaseParties.errorSearchFilteredCaseParties,
	            mimetype:"application/json"
	         });

	}



FilteredCaseParties.ajaxSearchFilteredCaseParties = function(button, /* String */partiesRk, /* String */
componentDivId, /* String */caseKey,
/* String */rels, /* String */desc, /* String */uiContextId) {

	
   if(FilteredCaseParties.validate(rels)) {
      dojo.io.bind( {
         method: "post",
         url: "SelFilteredPartyRelationship.do",
         postContent: "command=ajaxUpdateTableView&key="
               + partiesRk + "&divId=" + componentDivId + "&caseKey=" + caseKey
               + "&rels=" + rels + "&descr=" + desc + "&uiContextId="
               + uiContextId,
         load: FilteredCaseParties.createJSONCasePartyResults,
         error: FilteredCaseParties.errorSearchFilteredCaseParties,
         mimetype: "text/html"
      });
   }
   else {
	   button.disabled = false;
   }
}


FilteredCaseParties.ajaxRefreshFilteredCasePartiesAll = function() {

	    
	   
	dojo.io
	         .bind( {
	            url :"SelFilteredPartyRelationship.do?command=ajaxUpdateAllTableView" +
	                 "&componentName=" + FilteredCaseParties.COMPONENT_NAME +
	                 "&uiContextId=" + Case.UI_CONTEXT_ID,
	            load :FilteredCaseParties.createJSONCasePartyResultsAll,
	            error :FilteredCaseParties.errorSearchFilteredCaseParties,
	            mimetype :"text/html"
	         });

	}



FilteredCaseParties.ajaxRefreshFilteredCaseParties = function() {

   dojo.io
         .bind( {
            url :"SelFilteredPartyRelationship.do?command=ajaxUpdateTableView" +
                 "&componentName=" + FilteredCaseParties.COMPONENT_NAME +
                 "&uiContextId=" + Case.UI_CONTEXT_ID,
            load :FilteredCaseParties.createJSONCasePartyResults,
            error :FilteredCaseParties.errorSearchFilteredCaseParties,
            mimetype :"text/html"
         });

}

FilteredCaseParties.errorSearchFilteredCaseParties = function(type, error) {
   // TODO: Move this to a property
   alert("An error occurred trying to retrieve the User Information: "
         + error.message);

}


FilteredCaseParties.createJSONCasePartyResultsAll = function(type, data, evt) {
	
	
	var jsonModel = dojo.json.evalJson(data);
	//var jsonModel = dojo.json.evalJson(data);
	 for(var i = 0; i <jsonModel.data.length; i++)
		 {
		 var sectionName = jsonModel.data[i].fieldName;
		 var tableContent = jsonModel.data[i].tableContent;
		 var divId = sectionName + "_divId";
		 var div = dojo.byId(divId);
		 //var div = dojo.byId(divId);
 	     div.innerHTML = tableContent;
		 }
	 
	 if(window.parent.Dialog.activeDialog != null)
	      window.parent.Dialog.activeDialog.hide();
			
	 SaveChangesConfirmation.setPageDirty();
			  
	}



FilteredCaseParties.createJSONCasePartyResults = function(type, data, evt) {
	
	
   // TODO this might need to be changed to accept divId in data
	   var jsonModel = dojo.json.evalJson(data);
	   var divId = jsonModel.fieldName.toUpperCase() + "_divId";
	   var div = dojo.byId(divId);
	   div.innerHTML = jsonModel.tableContent;
	   if(window.parent.Dialog.activeDialog != null)
	      window.parent.Dialog.activeDialog.hide();
	   
	   SaveChangesConfirmation.setPageDirty();

}



FilteredCaseParties.validate = function(/*string*/rels) {
   var isValid = true;
   if(rels == "") {
      alert(AppProperties["select.relationship.to.continue.txt"]);
      isValid = false;
   }
   
   return isValid;
}
