var IncidentParties = {};

IncidentParties.addIncidentPartyRow = function(componentName, incidentKey, uiContextId) {

   var url = Global.CONTEXT_PATH + "/IncidentPartySearch.do?incidentKey="
         + incidentKey + "&componentName=" + componentName + "&uiContextId="
         + uiContextId;
   IFrameDialog.show( {
      url :url,
      width: 800, height: 500,
      title :AppProperties["add.subject.incident.action.label.txt"]
   });
}

IncidentParties.editParty = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Party.do?command=view&viewMode=EDITABLE&key=" + key +
         "&windowLayout=" + windowLayout +
         "&incidentKey=" + parentKey;
   Incident.redirect(url);
}

IncidentParties.viewParty = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Party.do?command=view&viewMode=READ_ONLY&key=" + key +
         "&windowLayout=" + windowLayout +
         "&incidentKey=" + parentKey;
   Incident.redirect(url);
}

IncidentParties.showIncidentPartyDetails = function(id, entityKey, windowLayout, viewMode) {
   App.showPopup("Party.do?key=" + id + "&incidentKey=" + entityKey
         + "&windowLayout=" + windowLayout, (screen.availWidth - 100), (screen.availHeight - 100), 0, 1, 0);
}

IncidentParties.deleteIncidentPartyRow = function(componentName, row, uiContextId) {
   var answer = confirm(AppProperties["incident.subject.delete.confirmation.txt"]);
   if (answer == true) {
      IncidentParties.ajaxRemoveIncidentParties(componentName, row, uiContextId);
   }

}

IncidentParties.ajaxSearchIncidentParties = function(button, /* String */partiesRk, /* String */
      componentDivId, /* String */incidentKey,
      /* String */rels, /* String */desc, /* String */uiContextId) {

   if(IncidentParties.validate(rels)) 
   {
      dojo.io.bind( {
         method: "post",
         url: "SelIncidentPartyRelationship.do",
         postContent: "command=ajaxUpdateTableView&key="
               + partiesRk + "&divId=" + componentDivId + "&incidentKey="
               + incidentKey + "&rels=" + rels + "&descr=" + desc
               + "&uiContextId=" + uiContextId,
         load: IncidentParties.createJSONIncidentPartyResults,
         error: IncidentParties.errorSearchIncidentParties,
         mimetype: "text/html"
      });
   }
   else 
   {
      button.disabled = false;
   }
}

IncidentParties.ajaxRemoveIncidentParties = function(/* String */componentName, /* int */
      rowId, /* String */uiContextId) {

   dojo.io.bind( {
      url :"SelIncidentPartyRelationship.do?command=ajaxUpdateTableView&componentName=" 
            + componentName + "&rowId=" + rowId
            + "&uiContextId=" + uiContextId,
      load :IncidentParties.createJSONIncidentPartyResults,
      error :IncidentParties.errorSearchIncidentParties,
      mimetype :"text/html"
   });

}

IncidentParties.errorSearchIncidentParties = function(type, error) {
   // TODO: Move this to a property
   alert("An error occurred trying to retrieve the User Information: "
         + error.message);

}

IncidentParties.createJSONIncidentPartyResults = function(type, data, evt) {
   // TODO this might need to be changed to accept divId in data
   var divId = dojo.byId("INCIDENTPARTYTABLE_divId");
   divId.innerHTML = data;
   if (window.parent.Dialog.activeDialog != null)
      window.parent.Dialog.activeDialog.hide();

   SaveChangesConfirmation.setPageDirty();
}

IncidentParties.validate = function(/*string*/rels) {
   var isValid = true;
   if(rels == "") {
      alert(AppProperties["select.relationship.to.continue.txt"]);
      isValid = false;
   }
   
   return isValid;
}