var PartyParties = {};

PartyParties.selectPartiesToAddToTable = function(fieldName, partyKey, partyTypeVal, partyCategoryVal, partySubcategoryVal, uiContextId) {
   var url = "LinkedPartySearch.do?command=searchForLinkedParties&fieldName=" + fieldName
	//var url = "LinkedPartySearch.do?fieldName=" + fieldName
		   + "&type=" + partyTypeVal
		   + "&category=" + partyCategoryVal
		   + "&subcategory=" + partySubcategoryVal
		   + "&uiContextId=" + uiContextId
		   + "&partyKey=" + partyKey;
   IFrameDialog.show({
      url: url,
      width: 800, height: 500,
      title: AppProperties["add.subject.subject.action.label.txt"]});
}

PartyParties.ajaxAddLinkedPartyTableRow = function(button, /* String */ fieldName,
      /* String */addedPartyKey, /* String */desc, /* String */uiContextId) {
   dojo.io.bind( {
      method: "post",
      url: "LinkedPartyRelDetails.do",
      postContent: "command=ajaxUpdateTableView"
           + "&fieldName=" + fieldName
           + "&addedParty=" + addedPartyKey
           + "&desc=" + desc
           + "&uiContextId=" + uiContextId,
      load: PartyParties.refreshLinkedPartyTable,
      error: PartyParties.errorUpdatingPartyRelationships,
      mimetype:"application/json"
   });
}

PartyParties.getLinkedPartyRelationshipDescription = function(/*String*/ form) {
   var f = FormUtil.getForm(form);
   return f.descArea.value;
}

PartyParties.ajaxRemoveLinkedPartyTableRow = function(/* String */fieldName, /* int */
      rowId, /* String */uiContextId) {
   dojo.io.bind( {
      url: "LinkedPartyRelDetails.do?command=ajaxUpdateTableView&deleteRowId="
            + rowId + "&fieldName=" + fieldName + "&uiContextId="
            + uiContextId,
      load: PartyParties.refreshLinkedPartyTable,
      error: PartyParties.errorUpdatingPartyRelationships,
      mimetype:"application/json"
   });
}

PartyParties.deleteLinkedPartyTableRow = function(fieldName, row, uiContextId) {
   var answer = confirm(AppProperties["subject.subject.delete.confirmation.txt"]);
   if (answer == true) {
      PartyParties.ajaxRemoveLinkedPartyTableRow(fieldName, row, uiContextId);
   }
}

PartyParties.editParty = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Party.do?command=view&viewMode=EDITABLE&key=" + key +
         "&windowLayout=" + windowLayout + "&partyKey=" + parentKey +
         "&referrer=" + Party.REFERRER;
   Party.redirect(url);
}

PartyParties.viewParty = function(/* long */key, /* long */parentKey, /* string */parentType) {
   var windowLayout = BrowserUtil.getRequestParameter("windowLayout", "MAIN_DIALOG");
   var url = Global.CONTEXT_PATH + "/Party.do?command=view&viewMode=READ_ONLY&key=" + key +
         "&windowLayout=" + windowLayout + "&partyKey=" + parentKey +
         "&referrer=" + Party.REFERRER;
   Party.redirect(url);
}

PartyParties.errorUpdatingPartyRelationships = function(type, error) {
   // TODO: Move this to a property
   alert("An error occurred trying to retrieve party relationship information:\n" + error.message);
}

PartyParties.linkedPartyDropdownSelectionChanged = function(/* String */fieldName, /* String */uiContextId) {
	var obj = document.getElementById(fieldName + '_linkedPartyDropdown');
	var selectedParty = obj.options[obj.selectedIndex].value;
	//SaveChangesConfirmation.setPageDirty();
	//alert("Party party has changed to : " + selectedParty);
	document.getElementById(fieldName + '_linkedParty').value = selectedParty;
	PartyParties.ajaxUpdateDropdown(selectedParty, fieldName, uiContextId);
}

PartyParties.ajaxUpdateDropdown = function(/* String */selectedPartyKey, /* String */fieldName, /* String */uiContextId) {
   dojo.io.bind( {
	      url: "LinkedPartyRelDetails.do?command=ajaxUpdateDropdown"
	    	  + "&selectedPartyKey=" + selectedPartyKey 
	    	  + "&fieldName=" + fieldName 
            + "&uiContextId=" + uiContextId,
      load: PartyParties.refreshLinkedPartyDropdown,
      error: PartyParties.errorUpdatingPartyRelationships,
      mimetype:"application/json"
   });
}

PartyParties.addPartyViaLinkedPartyDropdown = function(fieldName, partyKey, uiContextId) {
   var url = Global.CONTEXT_PATH + "/Party.do?command=newEntity";
   IFrameDialog.show({
      url: url,
      width: 500, height: 200,
      title: AppProperties["newParty.title.txt"]});
}

PartyParties.refreshLinkedPartyTable = function(type, data, evt) {

   var jsonModel = dojo.json.evalJson(data);
   
   var divId = jsonModel.fieldName.toUpperCase() + "_divId";
   var div = dojo.byId(divId);
   div.innerHTML = jsonModel.tableContent;
   
   if(window.parent.Dialog.activeDialog != null)
      window.parent.Dialog.activeDialog.hide();
   
   SaveChangesConfirmation.setPageDirty();
}

PartyParties.refreshLinkedPartyDropdown = function(type, data, evt) {

   var jsonModel = dojo.json.evalJson(data);
   
   var divId = jsonModel.fieldName + "_divId";
   var div = dojo.byId(divId);
   //div.innerHTML = jsonModel.dropdownContent;
   
   if(window.parent.Dialog.activeDialog != null)
      window.parent.Dialog.activeDialog.hide();
   
   SaveChangesConfirmation.setPageDirty();
}
