var Search = {};

/* this field is set by SearchCriteriaTag when it renders */
Search.FORM_NAME = null;

/* this field is populated by the SearchCriteriaTag when it renders DatePicker fields */
Search.DATE_FIELDS = new Array();

Search.addDateField = function(valueMap) {
   Search.DATE_FIELDS[Search.DATE_FIELDS.length] = valueMap;
}

Search.activateButton = function(id) {
   var button = dojo.byId(id);
   if (button) {
      button.disabled = false;
   }
}

Search.updateSelected = function(selectableElement) {
   var hidden = dojo.byId("selectedResults");
   if (selectableElement.type === 'radio') {
      if (selectableElement.checked) {
         hidden.value = selectableElement.value;
      } else {
         hidden.value = "";
      }
   } else {
      Search.toggleSelectedItem(selectableElement.value);
      // handle checkbox
      if (selectableElement.checked) {
         // element was checked. add it to hidden.
         if (hidden.value === '') {
            // no checked values stored, so just set the value
            hidden.value = selectableElement.value;
         } else {
            // append on the element value with a comma
            hidden.value = hidden.value + "," + selectableElement.value;
         }
      } else {
         // element was unchecked. remove it from hidden.
         hidden.value = hidden.value.replace(selectableElement.value, "");
         // clean up double, beginning, and trailing comma's
         hidden.value = hidden.value.replace(",,", ",");
         if (hidden.value.charAt(hidden.value.length - 1) == ',') {
            hidden.value = hidden.value.substring(0, hidden.value.length - 1);
         }
         if (hidden.value.indexOf(",") == 0) {
            hidden.value = hidden.value.substring(1, hidden.value.length);
         }
      }
   }
}

Search.toggleSelectedItem = function(itemKey) {
   SelectableTableModelService.toggleSelectedItemForSearchModel(
      Search.FORM_NAME, 
      itemKey,
      function(result)
      {
      }
   );
}

setButtonDisabled = function(buttonID, disabled)
{
   var button = document.getElementById(buttonID);
   if (button)
   {
      button.disabled = disabled;
   }  
}

Search.submitCasePartyResults = function(buttonID) {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      setButtonDisabled(buttonID, false);
      alert(AppProperties["search.select.a.subject.txt"]);
   } else {
      document.forms[0].action = "SelPartyRelationship.do";
      document.forms[0].submit();
   }
}

Search.submitFilterCasePartyResults = function(buttonID) {
	   var hidden = dojo.byId("selectedResults");
	   if (hidden.value === '') {
	      setButtonDisabled(buttonID, false);
	      alert(AppProperties["search.select.a.subject.txt"]);
	   } else {
	      document.forms[0].action = "FilterCasePartyRelationship.do";
	      
	       dojo.byId("command").value = "describeRelationship"; 
	      
	      document.forms[0].submit();
	   }
	}




Search.submitFilterIncidentPartyResults = function(buttonID) {
	   var hidden = dojo.byId("selectedResults");
	   if (hidden.value === '') {
	      setButtonDisabled(buttonID, false);
	      alert(AppProperties["search.select.a.subject.txt"]);
	   } else {
	      document.forms[0].action = "FilterIncidentPartyRelationship.do";
	      
	       dojo.byId("command").value = "describeRelationship"; 
	      
	      document.forms[0].submit();
	   }
	}



Search.submitLinkedPartyResults = function(buttonID) {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      setButtonDisabled(buttonID, false);
      alert(AppProperties["search.select.a.subject.txt"]);
   } else {
      document.forms[0].action = "LinkedPartyRelDetails.do";
      dojo.byId("command").value = "describeRelationship";
      document.forms[0].submit();
   }
}



Search.submitIncidentResults = function(buttonID) {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      setButtonDisabled(buttonID, false);
      alert(AppProperties["search.select.an.incident.txt"]);
   } else {
      // document.forms[0].action = "AjaxUpdateCaseIncidents.do";
      // document.forms[0].submit();
      var uiContextId = dojo.byId("uiContextId");
      var componentName = dojo.byId("componentName");
      var caseKey = dojo.byId("caseKey");
      
      var form = Search.getForm();
      var autoLinkPartiesFromIncidentElem = form.elements["autoLinkPartiesFromIncident"];
      var autoLinkPartiesFromIncident = (autoLinkPartiesFromIncidentElem && autoLinkPartiesFromIncidentElem.checked);
      
      var autoLinkFinancialItemsFromIncidentElem = form.elements["autoLinkFinancialItemsFromIncident"];
      var autoLinkFinancialItemsFromIncident = (autoLinkFinancialItemsFromIncidentElem && autoLinkFinancialItemsFromIncidentElem.checked);
      
      parent.CaseIncidents.ajaxSearchCaseIncidents(
            caseKey.value,
            componentName.value,
            hidden.value,
            uiContextId.value,
            autoLinkPartiesFromIncident,
            autoLinkFinancialItemsFromIncident);
   }
}

Search.submitReportResults = function() {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      alert(AppProperties["search.select.a.report.txt"]);
   } else {
      var uiContextId = dojo.byId("uiContextId");
      var componentName = dojo.byId("componentName");
      var efileKey = dojo.byId("efileKey");
      
      var form = Search.getForm();
      parent.EFileReports.ajaxSearchEFileReports(
            efileKey.value,
            componentName.value,
            hidden.value,
            uiContextId.value);
   }
}

Search.submitLinkedCaseResults = function() {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      alert(AppProperties["search.select.a.case.txt"]);
   } else {
      var uiContextId = dojo.byId("uiContextId");
      var componentName = dojo.byId("componentName");
      var caseKey = dojo.byId("caseKey");
      parent.LinkedCases.ajaxSearchForCases(caseKey.value, componentName.value, hidden.value, uiContextId.value);
   }
}

Search.submitIdenticalPartyResults = function() {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      alert(AppProperties["search.select.a.subject.txt"]);
   } else {
      var uiContextId = dojo.byId("uiContextId");
      var componentName = dojo.byId("componentName");
      var partyKey = dojo.byId("partyKey");
      parent.IdenticalParties.ajaxSearchIdenticalParties(partyKey.value, componentName.value, hidden.value, uiContextId.value);
   }
}

Search.submitIncidentPartyResults = function() {
   var hidden = dojo.byId("selectedResults");
   if (hidden.value === '') {
      alert(AppProperties["search.select.a.subject.txt"]);
   } else {
      document.forms[0].action = "SelIncidentPartyRelationship.do";
      document.forms[0].submit();
   }
}

Search.getForm = function()
{
   return document.getElementById(Search.FORM_NAME);
}

Search.submitForm = function(valueMap)
{
   FormUtil.submitForm(Search.getForm(), valueMap);
}

Search.handleDefaultSubmit = function(form)
{
   FormUtil.updateForm(form, {command: 'search', expandedCriteria: 'true'});
}

Search.search = function()
{
   var form = Search.getForm();
   Search.handleDefaultSubmit(form);
   form.submit();
}

Search.searchChange = function()
{
   Search.submitForm({command: 'search'});
}

Search.refresh = function()
{
   Search.submitForm();
}

Search.clearSearch = function()
{
   Search.submitForm({command: 'clear', expandedCriteria: 'true'});
}

Search.resetSearchForm = function()
{
   // reset the form.
   Search.getForm().reset();
   
   // reinitialize date picker fields from hidden fields
   for (var i = 0; i < Search.DATE_FIELDS.length; i++) {
      var dateID = Search.DATE_FIELDS[i];
      var hiddenID = dateID + "_HIDDEN";
      Search.copyValue(hiddenID, dateID);
   }
}

Search.copyValue = function(fromID, toID) {
   var fromEL = document.getElementById(fromID);
   var toEL = document.getElementById(toID);
   if (fromEL && toEL) {
      toEL.value = fromEL.value;
   }
}
