var App = {};

App.HAS_ERRORS = false;

App.dumpObjectProperties = function(obj) {
   alert("***** Start dumpObjectProperties...");
   for ( var i in obj) {
      alert(i + ": " + obj[i]);
   }
   alert("***** dumpObjectProperties complete.");
}

App.protectPage = function()
{
   if (sas_FastClick_createFastClickManager)
   {
      var menu = document.getElementById('mainToolBar');
      var eltsToProtect = [ menu ];
      
      var buttonIDs = [ 'Workflow.commit_button', 'Workflow.terminate_button', 'Workflow.activate_button' ];
      for (var i = 0; i < buttonIDs.length; i++)
      {
         var button = document.getElementById(buttonIDs[i]);
         if (button) eltsToProtect.push(button);
      }
  
      sas_FastClick_createFastClickManager();
      fastClickManager.setProtectionType('INCLUSIVE');
      fastClickManager.setProtectionAffectedObjects( eltsToProtect );
      fastClickManager.protectPage();  
    }
};

App.unprotectPage = function()
{
   if (typeof(fastClickManager) != 'undefined') {
      fastClickManager.unprotectPage();
   }
}

App.returnToBreadcrumb = function()
{
   var windowName = window.name;
   BreadcrumbService.getCurrentBreadcrumbURL(windowName, 
      {
         async: false, 
         callback: function(url) 
         { 
            window.location = url; 
         }
      });
}

App.removeBreadcrumb = function()
{
   var windowName = window.name;
   BreadcrumbService.removeBreadcrumb(windowName);
}

App.addBreadcrumb = function(referrer)
{
   if (typeof(BreadcrumbService) != 'undefined')
   { 
      
      //alert("referrer == " + referrer);
      BrowserUtil.setRequestParameter("referrer", referrer);
      
      var windowName = window.name;
      var url = BrowserUtil.getRequestURL().getPath();
      var params = BrowserUtil.getRequestParameters().toString();
      
      //alert("Adding breadcrumb :: \n windowName == " + windowName + " \n url == " + url + " \n params == " + params);
      BreadcrumbService.addBreadcrumb(windowName, url, params, {
         async: false/*, 
         callback: function() { alert("callback") }*/
      });
      
      //alert("after callback???")
   }
}

App.showPopup = function(url, width, height, resizable, scrollbars, status) {
   if(resizable == "" || resizable == "undefined") 
      resizable = 1;
   if(scrollbars == "" || scrollbars == "undefined") 
      scrollbars = 1;
   //hiding of status bar no longer works (anti-phising) within browser javascript
   if(status == "" || status == "undefined") 
      status = 1;
//   var w = screen.availWidth;
//   var h = screen.availHeight;
   var leftPos = 10;
   var topPos = 10;
   var theWindow = window.open(url, "appPopup", "resizable=" + resizable + ",scrollbars=" + scrollbars + 
         ",top=" + topPos + ",left=" + leftPos + ",status=" + status + ",width=" + width + ",height=" + height + 
         ",menubar=no,toolbar=no");
   theWindow.focus();
   return theWindow;
}

// Debug function for testing elapsed time.
App.timeTest = function(start, msg) {
   if (!msg)
      msg = "Time taken";
   var time = new Date().getTime() - start;
   alert(msg + " :: " + time);
}

// Browser Detection Javascript
App.whichBrs = function() {
   var agt = navigator.userAgent.toLowerCase();
   if (agt.indexOf("msie") != -1)
      return 'Internet Explorer';
   if (agt.indexOf("mozilla/5.0") != -1)
      return 'Mozilla';
   if (agt.indexOf('\/') != -1) {
      if (agt.substr(0, agt.indexOf('\/')) != 'mozilla') {
         return navigator.userAgent.substr(0, agt.indexOf('\/'));
      } else
         return 'Netscape';
   } else if (agt.indexOf(' ') != -1) {
      return navigator.userAgent.substr(0, agt.indexOf(' '));
   } else
      return navigator.userAgent;
}

function getDummyDojoEvent(parent) {
   var dummy;
   if (document.createEventObject) {
      // IE7; TODO: Test on IE6
      dummy = dojo.event.browser.fixEvent(document.createEventObject(), parent);
   } else {
      // Firefox
      var type = "HTMLEvents";
      dummy = document.createEvent(type);
      dummy.initEvent(type, false, true);
      dummy = dojo.event.browser.fixEvent(dummy, parent);
   }
   return dummy;
}

//javascript for TabSection / Tab
var appPreviousTabId = {};

function appSelectTab(tabSectionKey, tabId)
{
   var selectedTabId = appPreviousTabId[tabSectionKey];
   
	if (selectedTabId)
	{
		//var tabHeaderElem = document.getElementById(selectedTabId + "TabHeader");
		document.getElementById(selectedTabId + "TabContent").style.display = "none";
	}
	//var tabHeaderElem = document.getElementById(tabId + "TabHeader");
	document.getElementById(tabId + "TabContent").style.display = "";
	appPreviousTabId[tabSectionKey] = tabId;
}

// DHTML functions
function getTableBody(table) {
   if (!document.getElementsByTagName) {
      return;
   }
   var children = table.childNodes;
   for (var i = 0; i < children.length; i++) {
      if (children[i].tagName == "TBODY") {
         return children[i];
      }
   }
   return;
}

function removeFirstTableRow(tableId) {
	var table = dojo.byId(tableId);
	var tableBodyObj = getTableBody(table);
	if (!document.getElementsByTagName) {
		return;
	}
	var children = tableBodyObj.childNodes;
	if(children.length > 0) {
	  if(children[0].tagName == "TR") {
	     tableBodyObj.removeChild(children[0]);
	  }
	}
	return;
}



function tableBodyAddRow(table, content, currentContentArr, id, includeBottomBorder) {
   var rowNum = currentContentArr.length;
   
   if (!document.getElementsByTagName) {
      return;
   }
   if(rowNum == 0) {
      removeFirstTableRow(table);  
   }
   var children = table.childNodes;
   var tabBody;
   if(!(content instanceof Array)) {
     content = new Array(content);  
   }
   
   for (var i = 0; i < children.length; i++) {
      if (children[i].tagName == "TBODY") {
         tabBody = children[i];
         break;
      }
   }
   
   if (content instanceof Array) {
      for (var j = 0; j < content.length; j++) {
         var row = document.createElement("TR");
         if(content[j] instanceof Array) {
            for (var k=0; k < content[j].length; k++) {
               trAddColumn(row, content[j][k], includeBottomBorder);
            }
         } else {
            trAddColumn(row, content[j], includeBottomBorder);
         }
         
         var newRowNum = parseInt(rowNum + j);
         
         row.setAttribute("id", id);
         row.setAttribute("rowId", newRowNum);
         row.setAttribute("className", getAltTableRowClass(newRowNum % 2));
         row.setAttribute("class", getAltTableRowClass(newRowNum % 2));
         tabBody.appendChild(row);
         
         currentContentArr.push(newRowNum);
         
      }
   } else {
      var row = document.createElement("TR");
      trAddColumn(row, content, includeBottomBorder);

      row.setAttribute("id", id);
      row.setAttribute("rowId", rowNum);
      row.setAttribute("className", getAltTableRowClass(rowNum % 2));
      row.setAttribute("class", getAltTableRowClass(rowNum % 2));
      tabBody.appendChild(row);
      
   }
   
}

function trAddColumn(row, content, includeBottomBorder) {
   if(!content) {
      content = "";
   }
   if (content.childNodes) {
      row.appendChild(content);
   } else {
      var cell = document.createElement("TD");
      cell.setAttribute("className", "tableData");
      cell.setAttribute("class", "tableData");
      if(includeBottomBorder)
         cell.style.cssText = "BORDER-TOP-STYLE: 1px; BORDER-BOTTOM-STYLE: 1px";
      else {
         cell.style.cssText = "BORDER-TOP-STYLE: none";
      }
      if(content == "")
    	  content = "&nbsp;";
      cell.innerHTML = content;
      row.appendChild(cell);
   }
}

function getAltTableRowClass(/*int*/index) {
   switch(index) {
      case 0:
         return "dataRow1_tableRow";
      case 1:
      default:
         return "dataRow2_tableRow";
   }
}

function getElementByRowId(/*int*/rowId, /*String*/name) {
	  var htmlEls = document.getElementsByName(name);
	  for(var i=0; i < htmlEls.length; i++) {
	      var htmlEl = htmlEls[i];
	      if(htmlEl.getAttribute("rowId") == rowId) {
	         return htmlEl;
	      }
	   }
	   return null;
	}

function getElementByTagNameAndRowId(/*int*/rowId, /*String*/tagname, /*String*/name) {
  var htmlEls = document.getElementsByTagName(tagname);
  for(var i=0; i < htmlEls.length; i++) {
      var htmlEl = htmlEls[i];
      if(htmlEl.getAttribute("rowId") == rowId && htmlEl.getAttribute("name") == name) {
         return htmlEl;
      }
   }
   return null;
}

function getRowElementsByTagName(/*String*/tagname, /*String*/name) {
  var htmlEls = document.getElementsByTagName(tagname);
  var rows = [];
  var index = 0;
  for(var i=0; i < htmlEls.length; i++) {
      var htmlEl = htmlEls[i];
      if(htmlEl.getAttribute("name") == name) {
         rows[index] = htmlEl;
         index++;
      }
  }
  return rows;
}

function createHiddenField(fieldName, value) {
   var hiddenField = "<input type=\"hidden\" name=\"" + fieldName + "\" value=\"" + value + "\" />";
   return hiddenField;
}

//StringBuffer javascript
//******************************************* //
function StringBuffer() { this.buffer = []; }

StringBuffer.prototype.append = function(string)
{
this.buffer.push(string);
return this;
}

StringBuffer.prototype.toString = function()
{
   return this.buffer.join("");
}

function toJSONString(/*Array*/values) {
   var a = [];
   var index = 0;
   for (var k=0; k < values.length; k++) {
      var elementObj = new StringBuffer();
      if(k == 0) {
         elementObj.append("[");
      }
      if (typeof values[k] === 'string') {
          v = values[k];
          if (v) {
             if(typeof v === 'object') {
                var elementObj = new StringBuffer();
                elementObj.append("{");
                for (key in v) {
                  elementObj.append(key.toString() + ':\"' + v[key].toString()+ "\"");
                  elementObj.append(",");
                }
                var strValue = elementObj.toString();
                strValue = strValue.substr(0, strValue.length - 1);
                strValue = strValue + "}";
             } else {
                elementObj.append("\"");
                elementObj.append(v);
                elementObj.append("\"");
             }
          }
      } else if (typeof values[k] === 'boolean') {
         var elementObj = new StringBuffer();
         elementObj.append("\"");
         v = values[k];
         elementObj.append(v)
         elementObj.append("\"");
      }
      a.push(elementObj);
   }
   if(k == values.length) {
      elementObj.append("]");
   }

   return a.toString();
}

function activateButton(id) {
   var button = dojo.byId(id);
   if(button) {
      button.disabled = false;
   }
}

function limitText(limitField, limitNum) {
   if (limitField.value.length > limitNum) {
      limitField.value = limitField.value.substring(0, limitNum);
   }
}
