
/***********************************************************************************/
/* Copyright (c) 2011-2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved */
/*                                                                                 */
/* NAME:          ecm_zip                                                          */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       create a .zip of all the files in a directory without            */
/*                parent folder names                                              */
/* PARAMETERS:                                                                     */
/*                zippath: path of the directory to be zipped                      */
/*                rcVAR: mac variable for return code                              */
/*                outfref: fref for the location and name of the .zip file         */
/* NOTE:                                                                           */
/***********************************************************************************/


%macro ecm_zip(zippath=,rcvar=RC,outfref=);

%let &rcvar=0;
%if &sysscp=WIN %then
%do;  
    options noxwait;
%end;

data _null_;
     
     if fexist("&outfref") then rc=fdelete("&outfref");
     length zipcmd $ 1024;
%if &sysscp=WIN %then
%do; 
     /* window path may contain special characters. They need to be double quoted */ 
     zipcmd='"'||strip(symgetc('ecm_win_zip_cmd')) ||'" ' 
            ||'"' ||strip(pathname("&outfref"))  ||'" ' 
            ||' "' ||strip(symgetc('zippath'))    ||'"' 
            ;
%end;
%else
%do;
      zipcmd=strip("&ecm_unix_zip_cmd")||' '
             ||strip(pathname("&outfref"))||' '
             ||strip("&zippath"||'/*.*')
            ;
%end;
      call system(zipcmd);
      rc=sysrc();  
      call symput("&rcvar",strip(put(rc,best.)));

run;


%mend;
