
/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_efile_fincen_newctr_data                                   */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       Transform the RR data for new CTR efiling                        */
/* PARAMETERS:                                                                     */
/*                rr_subset: name of table containing all RR_RK to be refiled      */
/*                rr_config_rk: key of the report to efile (required)              */
/* NOTE:                                                                           */
/***********************************************************************************/
%macro ecmrr_efile_fincen_newctr_data(rr_subset_dsn=,form_config_rk=202);
                                          

%put %sysfunc(sasmsg(&smdds,GEN_MAC_START_NOTE,NOQUOTE,&sysmacroname)) ;

%let successYN=Y;

%ecmrr_efile_fincen_newctr_detail(rr_subset_dsn=&rr_subset_dsn,form_config_rk=&form_config_rk);
%if &successYN ne N %then
%do;
    %ecmrr_efile_fincen_newctr_sum(form_config_rk=&form_config_rk);
    %if &successYN=N %then %goto mExit;
%end;
%else
%do;
   %goto mExit;
%end;
 

%mExit: 

    %if &ecm_debug=N %then
    %do;
        proc datasets nolist nowarn lib=work;
             delete t_:
                    r_x:
             ;
        quit;
    %end;


%put %sysfunc(sasmsg(&smdds,GEN_MAC_END_NOTE,NOQUOTE,&sysmacroname)) ;

%mend;
 
