
/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_prvw_fincen_newctr_driver                                  */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       Create preview report for new FINCEN CTR form                    */
/* PARAMETERS:                                                                     */
/*                rr_rk: key of the report to preview (required)                   */
/*                form_config_rk: key of the form configuration record             */
/* NOTE:                                                                           */
/***********************************************************************************/
%macro ecmrr_prvw_fincen_newctr_driver(rr_rk=,form_config_rk=);
%put %sysfunc(sasmsg(&smdds,GEN_MAC_START_NOTE,NOQUOTE,&sysmacroname)) ;


proc sql noprint;
     select strip(FORM_AGENCY_CD),
            strip(FORM_TYPE_CD),
            strip(PREVIEW_MIME_TYPE_CD),
            strip(PREVIEW_FILE_PREFIX),
            strip(PREVIEW_PREPROCESS_PGM_NM) 
            into
            :form_agency_cd,
            :form_type_cd,
            :preview_mime_type_cd,
            :preview_file_prefix,
            :preview_preprocess_pgm_nm
     from ecm_db.form_config
     where form_config_rk=&form_config_rk;
quit;


/* Run the preprocessing code if it is defined */
 
%if &preview_preprocess_pgm_nm ne %then
%do;
%&preview_preprocess_pgm_nm(rr_rk=&rr_rk);
%end;
 
%ecmrr_fdf_newctr_driver(rr_rk=&rr_rk
                  ,form_config_rk=&form_config_rk                      
                      );

/* return the pdf to stored process _webout */ 

filename  infile "%sysfunc(pathname(work))&slash%trim(&preview_file_prefix).pdf";


data _null_;
   rc = stpsrv_header('Content-type',"application/pdf"); 

run;
  
 data _null_;

   filein = fopen('infile','I',1,'B');
   fileid = fopen('_webout','O',1,'B');
   
   rec = " ";

   do while(fread(filein)=0);
      rc = fget(filein,rec,1);
      rc = fput(fileid, rec);
      rc =fwrite(fileid);
   end;

 run;

 filename infile clear; 
   
%put %sysfunc(sasmsg(&smdds,GEN_MAC_END_NOTE,NOQUOTE,&sysmacroname)) ;
%MEXIT: 
%mend;
