/***********************************************************************************/
/* Copyright (c) 2011-2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved */
/*                                                                                 */
/* NAME:          ecm_ws_soap                                                      */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       call ECM web service with PROC SOAP                              */
/* PARAMETERS:    infref- fileref of the input request xml                         */
/*                outfref-fileref of the output response xml                       */
/*                efile_config_seq_no= key of efile config data to be processed    */
/* NOTE:                                                                           */
/***********************************************************************************/

%macro ecm_ws_soap(infref=request,outfref=response,cfgfref=);

%if not %symexist(ecm_ws_url) %then
%do;
    %ecm_ws_get_url; 
%end;

proc soap IN=&infref
          OUT=&outfref
          SRSURL="&ecm_ws_srsurl"
          URL="&ecm_ws_url" 
          %if %str(&ecm_webusername) ne %str() and
              %str(&ecm_webpassword) ne %str() %then
          %do;
             
             wssusername="&ecm_webusername" wsspassword="&ecm_webpassword"  
          %end;  
          %else
          %do;
             /* retreieve the user account and password from SAS metadata server */
             wssauthdomain='DefaultAuth'
          %end; 
            SOAPACTION="http://sas.com/solutions/casemgmt/webservice/CaseManagementServiceInterface/create"
            %if %str(&cfgfref) ne %str() %then
            %do;
                %if %sysfunc(fexist(&cfgfref)) %then
                %do;
                    configfile="%sysfunc(pathname(&cfgfref))"
                %end;
            %end;
;
run;
%mend;
