
/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_efile_fincen_sar_data                                      */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       Transform the RR data for SAR efiling                            */
/* PARAMETERS:                                                                     */
/*                rr_subset: name of table containing all RR_RK to be refiled      */
/*                rr_config_rk: key of the report to efile (required)              */
/* NOTE:                                                                           */
/***********************************************************************************/
%macro ecmrr_efile_fincen_sar_data(rr_subset_dsn=,form_config_rk=201);
                                          

%put %sysfunc(sasmsg(&smdds,GEN_MAC_START_NOTE,NOQUOTE,&sysmacroname)) ;

%let successYN=Y;

%ecmrr_efile_fincen_sar_detail(rr_subset_dsn=&rr_subset_dsn,form_config_rk=&form_config_rk);
%if &successYN ne N %then
%do;
    %ecmrr_efile_fincen_sar_sum(form_config_rk=&form_config_rk);
    %if &successYN=N %then %goto mExit;
%end;
%else
%do;
   %goto mExit;
%end;
    
%if &successYN ne N %then
%do;
    %if &efile_rk ne %then
    %do;
    %ecmrr_efile_fincen_sar_attach(  attachment_nm_var=x_sar_attachment_nm,
                                     seq_no_var=z_rr_seq_no,
                                     key_var=rr_rk,
                                     efile_rk=&efile_rk,
                                     form_config_rk=&form_config_rk);
    %end;
    %if &successYN=N %then %goto mExit;
%end;
%else
%do;
   %goto mExit;
%end;

%mExit: 

%put %sysfunc(sasmsg(&smdds,GEN_MAC_END_NOTE,NOQUOTE,&sysmacroname)) ;

%mend;
 
