
/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_efile_fincen_ui_data                                       */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       Extract transmitter information                                  */
/* PARAMETERS:                                                                     */
/*                outdsn: output table name                                        */
/*                form_type_cd: form type                                          */                       
/* NOTE:          if efile_rk is not empty, transmitter info will pull from        */
/*                the efile record                                                 */
/*                Otherwise the following required macro variables should be       */
/*                defined in ecmrr_efile_transmitter_var macro.                    */ 
/***********************************************************************************/

%macro ecmrr_efile_fincen_ui_data(outdsn=efile_ui_data,form_type_cd=);


%put %sysfunc(sasmsg(&smdds,GEN_MAC_START_NOTE,NOQUOTE,&sysmacroname)) ;


data _null_;
     set ecm_db.efile_udf_def end=eof;
    where udf_type_nm in ('VARCHAR' 'CHAR');
    call symput("EFILE_UDF_NM"||strip(put(_n_,best.)),strip(udf_nm));
    if eof then call symput('EFILE_UDF_CNT',put(_n_,best.)); 
run;


%do i=1 %to &efile_udf_cnt;
   %let &&&efile_udf_nm&i=;
%end;



%ecmrr_efile_fincen_trnsmttr_var(form_type_cd=&form_type_cd);

data &outdsn;
      length field_nm $ 128 string_value $ 4000 ;
      length row_no numeric_value 8;
      length datetime_value $19;
      %do i=1 %to &efile_udf_cnt;
           field_nm="EFILE.&&&efile_udf_nm&i";
           string_value=symgetc("&&&efile_udf_nm&i");
           output;
      %end;
      
run;

%put %sysfunc(sasmsg(&smdds,GEN_MAC_END_NOTE,NOQUOTE,&sysmacroname)) ;



%mend;
