
/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_fdf_directrep                                              */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       create fdf values for simple direct fields with repetition       */
/* PARAMETERS:    P1 - must be the number of repetition                            */
/* NOTE:                                                                           */
/*                source_field_name and target_field_nm will be suffixed with the  */
/*                index representing the iteration.                                */
/***********************************************************************************/
%macro ecmrr_fdf_directrep(source_field_nm=,target_field_nm=,source_field_exp=,P1=);

%local i;
%do i=1 %to &P1;

%let new_source_field_nm=&source_field_nm._&i;
%let new_target_field_nm=&target_field_nm._&i;

%if %str(&source_field_exp) ne %str() %then
%do;
    
    %let new_source_field_exp=%sysfunc(tranwrd(&source_field_exp,&source_field_nm,&new_source_field_nm));
    source_field_value=strip(%unquote(&new_source_field_exp));
%end;
%else
%do; 
    source_field_value=strip(&new_source_field_nm);
%end;

 
if source_field_value > '' then
do;

    if length(source_field_value) <= 200 then
    do; 
        outline='<</T('
            ||"&new_target_field_nm"
            ||')/V('
            ||strip(source_field_value)
            ||')>>';

        put outline;
    end;
    else
    do;
        outline='<</T('
            ||"&new_target_field_nm"
            ||')/V('    
             
        ;
        put outline;
        startpos=1;
        do while (substrn(source_field_value,startpos,255) ne '');
            outline=substrn(source_field_value,startpos,255)||'\';
            put outline;
            startpos=startpos+255;
        end;
        outline=')>>';
        put outline;
    end;
 
end;
%end;
%mend;
