/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_fdf_new_merger                                             */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       Merge fdfs into a final pdf                                      */
/* PARAMETERS:    page_log_table_nm: name of the table containing                  */
/*                the fdf and pdf template file names  that need to be merged      */
/*                into a single pdf.                                               */
/***********************************************************************************/

%macro ecmrr_fdf_new_merger(page_log_table_nm=page_log
                            );
 
                      
%put %sysfunc(sasmsg(&smdds,GEN_MAC_START_NOTE,NOQUOTE,&sysmacroname)) ;



data _null_ / picklist='entcm/entcmjars.txt';
   
    set &page_log_table_nm end=eof;

   
    if _n_=1 then
    do;
       /* Instantiate the FDFMerger java object */
       declare javaobj f;
       f = _new_ javaobj('com/sas/solutions/casemgmt/util/pdf/FDFMerger');

       /* Set the directories for the master pdf form, temporary fdf files, and the output pdf */
       formpath="&ecm_config_path&slash.Source&slash.form_template";
       temppath=pathname('work');
       outpath=pathname('work');
       f.callVoidmethod('setPaths',strip(formpath),strip(temppath),strip(outpath));
   end;
    
   retain temppath;
   
    if fileexist(strip(temppath)||"&slash"||strip(fdf_nm)) then 
    do;
       f.callVoidmethod('addPage'
                        ,strip(template_nm)
                        ,strip(fdf_nm)
                        );
    end;  
   
   if eof then
   do;
 
   /* Build the final pdf output */
      f.callVoidmethod('buildMasterPDFDocument',strip(output_nm));  
      f.flushjavaoutput();
      f.delete();
 
  end;
  
run;

 

   
%put %sysfunc(sasmsg(&smdds,GEN_MAC_END_NOTE,NOQUOTE,&sysmacroname)) ;
MEXIT: 
%mend;
