
/***********************************************************************************/
/* Copyright (c) 2012, SAS Institute Inc., Cary, NC, USA, All Rights Reserved      */
/*                                                                                 */
/* NAME:          ecmrr_fincen_new_sas_format                                      */
/* PRODUCT:       Enterprise Case Management                                       */
/* PURPOSE:       Define sas formats for formatting FINCEN data                    */
/* PARAMETERS:                                                                     */
/* NOTE:          This macro will be called by                                     */
/*                     ecmrr_prvw_fincen_sar_data                                   */
/***********************************************************************************/

%macro ecmrr_fincen_new_sas_format(form_config_rk=);

 %put %sysfunc(sasmsg(&smdds,GEN_MAC_START_NOTE,NOQUOTE,&sysmacroname)) ;

proc sql;
     create table _ref_format as
     select distinct
              a.ref_table_nm as fmtname
            , a.value_cd  as start
            , a.value_desc as label
            , 'C' as type 
     from ecm_db.ref_table_value as a,
          ecm_db.form_preview_field_config as b
     where form_config_rk=&form_config_rk 
           and (a.ref_table_nm='X_RT_'||substr(b.source_field_nm,3,length(b.source_field_nm)-5) or
                a.ref_table_nm='X_RT_'||substr(b.source_field_nm,4,length(b.source_field_nm)-6)
                )

     order by fmtname
     ;

quit;
proc format cntlin=_ref_format;
run; 

         


%if &syserr > 4 %then 
%do;
     %let successYN=N;
     %put %sysfunc(sasmsg(&smdds,GEN_STP_ABORT,NOQUOTE,&sysmacroname)) ;
     %goto mExit;
%end;

%mExit:

%put %sysfunc(sasmsg(&smdds,GEN_MAC_END_NOTE,NOQUOTE,&sysmacroname)) ;
%mend;
